//see wordp.t
#include <vector>
#include <iostream>
bool leet54SpiralMatrixUtilNext(int iSide, int &x, int &y, int &iDirection, vector<bool>&aVisited)
{
	static struct
	{
		int x;
		int y;
	} aInc[4] =
	{
		{ 0, 1 },  //x is row, not x coordi
		{ 1, 0 },
		{ 0, -1 },
		{ -1, 0 },
	};
	int x1 = x + aInc[iDirection].x;
	int y1 = y + aInc[iDirection].y;
	bool bDirectionChanged = false;
	if (x1 < 0 || x1 >= iSide || y1 < 0 || y1 >= iSide || aVisited[x1 * iSide + y1])
		iDirection = (iDirection + 1) % 4;
	x = x + aInc[iDirection].x;
	y = y + aInc[iDirection].y;
	return true;
}
bool leet54SpiralMatrixUtil(vector<int> &aInput, int iSide, vector <int> &aOutput)
{
	int x = 0, y = 0, iDirection = 0;
	vector<bool> aVisited(vector<bool>(iSide * iSide, false));
	int index = 0, num = iSide * iSide;
	cout << "leet54SpiralMatrixUtil spiral from top left, clockwise: " << endl;
	while (index < num)
	{
		cout << aInput[x * iSide + y] << " ";
		aOutput[index] = aInput[x * iSide + y];
		aVisited[x * iSide + y] = true;
		if (!leet54SpiralMatrixUtilNext(iSide, x, y, iDirection, aVisited))
		{
			cout << "error" << endl;
			return false;
		}
		index++;
	}
	cout << "done " << endl;
	return true;
}
void leet54SpiralMatrixTest()
{
	vector<int> aInput =
	{
		1, 2, 3, 4,
		5, 6, 7, 8,
		9, 10, 11, 12,
		13, 14, 15, 16
	};
	int iSide = 4;
	vector <int> aOutput(iSide * iSide);
	if (!leet54SpiralMatrixUtil(aInput, iSide, aOutput))
		cout << "leet54SpiralMatrixUtil failed" << endl;
	_ASSERT(aOutput[6] == 16);
	_ASSERT(aOutput[12] == 6);
	bool failed = (aOutput[6] != 16 || aOutput[12] != 6);
	cout << "leet54SpiralMatrixTest iSide = " << iSide << ", success = " << !failed;
}

//2404 Rotate Image/matrix leet.c
//#define WXC_46_OFFICIAL //From net, otherwise mine, easier to understand
void leet46RotateImagePrint(const vector< vector<int> >& aInput, string msg)
{
	cout << msg << endl;
	size_t n = aInput.size();
	for (size_t i = 0; i < n; i++)
	{
		for (size_t j = 0; j < n; j++)
			cout << aInput[i][j] << " ";
		cout << endl;
	}
	cout << endl;
}
void leet46RotateImageUtil(vector< vector<int> >& aInput)
{ //rotate to right
	size_t n = aInput.size(), debugLoopNum = 0;
#ifdef WXC_46_OFFICIAL
	int iLimit = n / 2;
	for (size_t i = 0; i <= iLimit; i++)
		for (size_t j = i; j <= iLimit - i; j++) //topleft quarter
#else
	for (size_t i = 0; i < n - 1; i++)
		for (size_t j = i; j < n - i - 1; j++) //reversed triangle
#endif
		{
			int temp = aInput[i][j]; //save self at top
			aInput[i][j] = aInput[n - j - 1][i]; //left side take my spot
			aInput[n - j - 1][i] = aInput[n - i - 1][n - j - 1]; //bottom to left
			aInput[n - i - 1][n - j - 1] = aInput[j][n - i - 1]; //right to bottm
			aInput[j][n - i - 1] = temp; //top to left
			string str = format("i = {}, j = {}", i , j);
			leet46RotateImagePrint(aInput, str);
			debugLoopNum++;
		}
	cout << "n = " << n << ", debugLoopNum = " << debugLoopNum << endl;
}
void leet46RotateImageUtilFlip(vector< vector<int> >& aInput) // trick way flip left right, then diagonal to low-right.
{ //rotate to right
	size_t iSizeX = aInput.size(), iSizeY = aInput[0].size();
	assert(iSizeX == iSizeY && iSizeY); //not things non-square
	size_t midX = iSizeX / 2;
	leet46RotateImagePrint(aInput, "before process");
	for (size_t i = 0; i < midX; i++)
		for (size_t j = 0; j < iSizeY; j++)
			swap(aInput[j][i], aInput[j][iSizeX - 1 - i]);
	leet46RotateImagePrint(aInput, "after flip horizontal");
	for (size_t i = 0; i < iSizeX - 1; i++) //no need to do last
		for (size_t j = 0; j < iSizeY - i; j++)
			swap(aInput[j][i], aInput[iSizeX - 1 - i][iSizeX - 1 - j]);
	leet46RotateImagePrint(aInput, "after diagnal");
}
void leet46RotateImageTest()
{
	struct ST_DATA {
		vector< vector<int> > maInput;
		vector<int> maBottomRow;
	};
	vector < ST_DATA > aTestData =
	{
		{
			{
				{ 1,2,3 },
				{ 4,5,6 },
				{ 7,8,9 },
			},
			{ 9,6,3 },
		},
		{
			{
				{ 1,2,3,4 },
				{ 5,6,7,8 },
				{ 9, 10, 11, 12 },
				{ 13, 14, 15, 16 },
			},
			{ 16,12, 8, 4 },
		}
	};
	size_t iSize = aTestData.size();
	cout << "leet46RotateImageTest" << endl;
	int iStart = 0; //wxc
	for (size_t i = iStart; i < iSize; i++)
	{
		cout << "started i = " << i << endl;
		vector< vector<int> > aInput = aTestData[i].maInput;
		leet46RotateImageUtil(aInput);
		size_t n = aTestData[i].maInput.size();
		assert(aInput[n - 1] == aTestData[i].maBottomRow);
		aInput = aTestData[i].maInput;
		leet46RotateImageUtilFlip(aInput);
		assert(aInput[n - 1] == aTestData[i].maBottomRow);
	}
	cout << " success" << endl;
}


//RotateVector 2404, see algo.c
void meRotateVectorUtilInplace(vector<int>& aInput, int iSteps) //rotate to right. copied fr :rotate offical sure not easy
{ //2404 have to inli
	size_t iSize = aInput.size();
	assert(iSteps < iSize);
	vector<int>::iterator pBufHead = aInput.end() - iSteps;
	vector<int>::iterator pDst = aInput.begin(), //to be filled, just go forward until pBufHead
		pSrc = pBufHead, //the ones after pBufHead are newly moved here from head area, to be moved to new locaion when pSrc is reset
		LAST = aInput.end();
	cout << endl << "Input: " << "with iSteps " << iSteps << " : ";
	for (int i : aInput)
		cout << i << " ";
	cout << endl;
	while (pDst != pSrc)
	{
		swap(*pDst++, *pSrc++);
		if (pSrc == LAST)
		{
			pSrc = pBufHead;
			cout << "aInput: ";
			for(int i: aInput)
				cout << i << " ";
			cout << endl;
			cout << "pSrc reset to " << *pSrc << endl;
		}
		else if (pDst == pBufHead)
		{
			pBufHead = pSrc; 
			cout << "only portion of buffer is used, reset pBufHead, the start of shinked buffer, to " << *pBufHead << endl;
		}
	}
	cout << "output: ";
	for (int i : aInput)
		cout << i << " ";
	cout << endl;
}
void meRotateVectorUtilWithBuf(vector<int>& aInput, int iSteps)
{
	size_t iSize = aInput.size();
	vector<int> aTemp(iSize);
	for (size_t i = 0; i < iSize; i++) //instead of limit the loop element, we limit the loop count number
		aTemp[(i + iSteps) % iSize] = aInput[i];
	swap(aInput, aTemp);
}
void meRotateVectorTest()
{
	struct ST_DATA {
		vector<int> maInput;
		int miSteps; //rotate to right
		vector<int> maResult;
	};
	vector < ST_DATA > aTestData =
	{
		{
			{  },
			2,
			{  },
		},
		{
			{ 2 },
			3,
			{ 2 },
		},
		{
			{ 1,2,3,4,5 },
			2,
			{ 4,5, 1,2,3 },
		},
		{
			{ 1,2,3,4,5 },
			3,
			{ 3, 4,5, 1,2, },
		},
		{
			{ 1,2,3,4,5,6,7,8,9 },
			3,
			{ 7,8,9,1,2,3,4,5,6,},
		},
	};
	size_t iSize = aTestData.size();
	cout << __func__ << endl;
	int iStart = 2; //wxc
	for (size_t i = iStart; i < iSize; i++)
	{
		cout << "started i = " << i << endl;
		if (aTestData[i].miSteps < aTestData[i].maInput.size())
		{
			vector<int> aTemp = aTestData[i].maInput;
			vector<int>::iterator itMid = aTemp.end() - aTestData[i].miSteps;
			rotate(aTemp.begin(), itMid, aTemp.end());
			assert(aTemp == aTestData[i].maResult);
			aTemp = aTestData[i].maInput;
			meRotateVectorUtilInplace(aTemp, aTestData[i].miSteps);
			assert(aTemp == aTestData[i].maResult);
			aTemp = aTestData[i].maInput;
			meRotateVectorUtilWithBuf(aTemp, aTestData[i].miSteps);
			assert(aTemp == aTestData[i].maResult);
		}
	}
	cout << " success" << endl;
}
